#!/bin/sh

# usage [MDVIEW='./mdview --mdview-option...'] $0

for p in test/script/*.sh; do
	case $p in (*/TODO* | */commonmark*) continue ;; esac;
	$p;
done | gawk '
###gawk
### highlight differences (requires gawk)
{
	n = split($0, a, /{\+|\+}|\[-|-\]/, seps)
	for (i = 0; i < n; i++) {
		switch (seps[i]) {
			case "{+" : printf "\033[32m%s", seps[i]; break
			case "+}" : printf "%s\033[0m",  seps[i]; break
			case "[-" : printf "\033[31m%s", seps[i]; break
			case "-]" : printf "%s\033[0m",  seps[i]; break
		}
		printf "%s", a[i+1]
	}
	printf "\n"
}

### count results
# \033 comes from script/lib/common.sh main()
/\033.*PASS /    { ++pass    }
/\033.*FAIL /    { fail+=$3  }
/\033.*INVALID / { ++invalid }
/\033.*CREATED / { ++created }
END {
	printf "===== PASS %d, FAIL %d%s%s =====\n", pass, fail, invalid+0 ?", INVALID "invalid :"", created+0 ?", CREATED "created :""
	exit fail+invalid>0
}
###gawk'
